

package org.apache.drill.exec.expr.fn.impl;

import org.apache.drill.exec.expr.DrillSimpleFunc;
import org.apache.drill.exec.expr.annotations.FunctionTemplate;
import org.apache.drill.exec.expr.annotations.FunctionTemplate.NullHandling;
import org.apache.drill.exec.expr.annotations.Output;
import org.apache.drill.exec.expr.annotations.Workspace;
import org.apache.drill.exec.expr.annotations.Param;
import org.apache.drill.exec.expr.holders.*;
import org.apache.drill.exec.record.RecordBatch;

/*
 * This class is generated using freemarker and the DateIntervalFunctionTemplates/ToDateTypeFunctions.java template.
 */

@FunctionTemplate(name = "to_date" , scope = FunctionTemplate.FunctionScope.SIMPLE, nulls = NullHandling.NULL_IF_NULL)
public class GToDate implements DrillSimpleFunc {


    @Param  VarCharHolder left;
    @Param  VarCharHolder right;
    @Workspace org.joda.time.format.DateTimeFormatter format;
    @Output DateHolder out;

    public void setup() {
        // Get the desired output format
        byte[] buf = new byte[right.end - right.start];
        right.buffer.getBytes(right.start, buf, 0, right.end - right.start);
        String formatString = new String(buf, com.google.common.base.Charsets.UTF_8);
        format = org.joda.time.format.DateTimeFormat.forPattern(formatString);
    }

    public void eval() {

        // Get the input
        byte[] buf1 = new byte[left.end - left.start];
        left.buffer.getBytes(left.start, buf1, 0, left.end - left.start);
        String input = new String(buf1, com.google.common.base.Charsets.UTF_8);

        out.value = (org.joda.time.DateMidnight.parse(input, format).withZoneRetainFields(org.joda.time.DateTimeZone.UTC)).getMillis();
    }
}

